=== debian/changelog ===
rocm-hipamd (5.2.3-8) unstable; urgency=medium

  * hipcc: Fix typo in dependency relation

 -- Christian Kastner <ckk@debian.org>  Mon, 01 May 2023 00:46:36 +0200

rocm-hipamd (5.2.3-7) unstable; urgency=medium

  * hipcc: Fix Depends to enable transition from split clang package

  * Temporarily undo some changes to reduce the bookworm diff:
    + Drop building of tests, and libclang-rt-15-dev dependency
    + Drop rocminfo Build-Depends (only needed for tests)
    + Change back to Architecture: any
    + Undo Standards-Version bump
    + Undo autopkgtest addition

 -- Christian Kastner <ckk@debian.org>  Sun, 30 Apr 2023 16:05:27 +0200

rocm-hipamd (5.2.3-6) unstable; urgency=medium

  * Reduce arch to amd64, arm64, ppc64el
  * libamdhip64-5: Add dependency on libamd-comgr2 (Closes: #1032677)
  * Add myself to Uploaders
  * Fix Maintainer (same list, different name)

 -- Christian Kastner <ckk@debian.org>  Fri, 10 Mar 2023 23:38:51 +0100

rocm-hipamd (5.2.3-5) unstable; urgency=medium

  * d/{libamdhip64-dev,rules}: fix version file
    Closes: #1031264
  * add d/p/0020-replace-x86_64-with-variables.patch
    to fix build on aarch64
  * d/control: add file to hipcc dependencies
  * d/control: add dependencies for find_package(hip)
    Closes: #1031538
  * add d/p/0021-fix-default-cmake-build-on-unsupported-gpus.patch
    to enable gpu arch autodetection with find_package(hip)
  * d/not-installed: ignore doxygen docs
  * d/p/000{4,8,9}*.patch: change hip-lang cmake files,
    to partially fix #1031540
  * d/copyright: update copyright date
  * d/control: add self to uploaders
  * cleanup patch metadata

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 19 Feb 2023 03:51:26 -0700

rocm-hipamd (5.2.3-4) unstable; urgency=medium

  * d/t/hipcc: also skip when no kfd driver is loaded.

 -- Étienne Mollier <emollier@debian.org>  Sat, 21 Jan 2023 12:54:49 +0100

rocm-hipamd (5.2.3-3) unstable; urgency=medium

  * d/control: build depends on libclang-rt-15-dev.
  * d/control: hipcc depends on libclang-rt-15-dev.
  * d/t/hipcc: add; basic script testing hipcc.
  * d/t/hipconfig: add; script skipping hipconfig if no amdgpu is available.
  * d/t/control: add hipcc to superficial autopkgtests.
  * d/t/control: run the d/t/hipconfig test script instead of the command;
    this allows us to trigger conditions for when hardware is not available
    and the script has to be skipped.

 -- Étienne Mollier <emollier@debian.org>  Wed, 18 Jan 2023 20:35:17 +0100

rocm-hipamd (5.2.3-2) unstable; urgency=medium

  [ Cordell Bloor ]
  * d/patches: add 0020-hipcc-remove-rpath-flags.patch
    Closes: #1021642
  * d/rules: trim unnecessary rules
  * d/rules: strip RUNPATH from libamdhip64.so
  * debian/patches: backport 56b3260 from upstream
    Closes: #1021643
  * d/rules: disable creation of duplicate files
  * d/patches: fix search paths when building with g++
  * d/patches: add 0002-fix-cmake-library-notfound-check.patch
  * d/libamdhip64-dev.install: install /usr/share/hip/version

  [ Étienne Mollier ]
  * 0005-clang-15.patch: also adjust llc postfix.
    Thanks to Jakub Jaszewski
  * d/t/control: check hipconfig doesn't output error messages.
  * d/control: hipcc depends on rocminfo.
  * d/control: declare compliance to standards version 4.6.2.
  * d/copyright: update copyright year.
  * d/rules: build tests in parallel.
  * d/rules: set library path to find the freshly built library.
  * d/rules: force run tests sequentially; avoid bus contention on the GPU.

 -- Étienne Mollier <emollier@debian.org>  Sat, 14 Jan 2023 11:16:01 +0100

rocm-hipamd (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/control: build depends on ROCm 5.2.

 -- Étienne Mollier <emollier@debian.org>  Thu, 20 Oct 2022 21:20:33 +0200

rocm-hipamd (5.2.3-1~0exp1) experimental; urgency=medium

  * d/control: append numerous missing llvm 15 experimental packages.

 -- Étienne Mollier <emollier@debian.org>  Wed, 05 Oct 2022 19:43:48 +0200

rocm-hipamd (5.2.3-1~0exp0) experimental; urgency=medium

  [ Étienne Mollier ]
  * New upstream version
  * Add salsa-ci file (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Refresh or unfuzz multiple patches with the new upstream version.
  * 0002-orthograph-patch-for-rocclr.patch: remove; applied upstream.
  * 0008-dotdots.patch: refresh; half the patch applied upstream.
  * 0012-typo.patch: forward upstream.
  * d/{rules,not-installed}: declare files not installed instead of running rm
    (yet keep `rm bin/.hipVersion` around).
  * d/{libamdhip64-dev.install,not-installed}: sort missing files.
  * d/control: bump build-dependency to llvm 15 to fix various ftbfs.
  * 0013-hipcc-hip-version.patch: refer to a newly open bug on the topic.
  * 0005-clang-14.patch: update and rename to 0005-clang-15.patch following
    llvm 15 version bump.
  * d/libamdhip64-5.symbols: append new symbols.

  [ Cordell Bloor ]
  * 0005-clang-15.patch: use version-agnostic checks
  * Add 0015-default-hip-clang-path.patch
  * Add 0016-default-device-lib-path.patch
  * Add 0017-default-rocm-path.patch
  * Add 0018-rocm-path-flag.patch
    Closes: #1021275

  [ Étienne Mollier ]
  * d/salsa-ci.yml: don't trigger i386 tests.
  * d/control: add patchelf as build-dependency.
  * d/rules: cleanup rpath in libhiprtc-builtins.so.

 -- Étienne Mollier <emollier@debian.org>  Tue, 04 Oct 2022 22:00:05 +0200

rocm-hipamd (5.0.0-1) unstable; urgency=medium

  * Migrate rocm-hipamd to unstable.

 -- Étienne Mollier <emollier@debian.org>  Wed, 31 Aug 2022 19:11:39 +0200

rocm-hipamd (5.0.0-1~exp2) experimental; urgency=medium

  * Fix 0005-clang-14.patch: do not touch HIP_COMPILER.
  * Add 0013-hipcc-hip-version.patch to hardcode --hip-version= while there is
    no way to feed this information in an FHS compliant way.
  * Add 0014-gcc-12.patch: fix ftbfs with gcc-12.
  * d/rules: configure OFFLOAD_ARCHS_STR to build on hosts w/o amdgpu.  The

