=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipamd-$1.tar.gz%" \
    https://github.com/rocm-developer-tools/hipamd/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-hip-$1.tar.gz%, component=hip" \
    https://github.com/rocm-developer-tools/hip/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz same
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-clr-$1.tar.gz%, component=clr" \
    https://github.com/rocm-developer-tools/rocclr/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz same
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-opencl-$1.tar.gz%, component=opencl" \
    https://github.com/radeonopencompute/rocm-opencl-runtime/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz same
